<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2020 osCommerce

  Released under the GNU General Public License
*/

define('HEADING_TITLE', 'Devises');

define('TABLE_HEADING_CURRENCY_NAME', 'Devise');
define('TABLE_HEADING_CURRENCY_CODES', 'Code');
define('TABLE_HEADING_CURRENCY_VALUE', 'Valeur');
define('TABLE_HEADING_ACTION', 'Action');

define('TEXT_INFO_EDIT_INTRO', 'Merci de faire les changements nécessaires');
define('TEXT_INFO_COMMON_CURRENCIES', '-- Devises communes --');
define('TEXT_INFO_CURRENCY_TITLE', 'Titre : %s');
define('TEXT_INFO_CURRENCY_CODE', 'Code : %s');
define('TEXT_INFO_CURRENCY_SYMBOL_LEFT', 'Symbole gauche : %s');
define('TEXT_INFO_CURRENCY_SYMBOL_RIGHT', 'Symbole droit : %s');
define('TEXT_INFO_CURRENCY_DECIMAL_POINT', 'Point décimal : %s');
define('TEXT_INFO_CURRENCY_THOUSANDS_POINT', 'Séparateur de milliers : %s');
define('TEXT_INFO_CURRENCY_DECIMAL_PLACES', 'Nombre de décimales : %s');
define('TEXT_INFO_CURRENCY_LAST_UPDATED', 'Dernière mise à jour : %s');
define('TEXT_INFO_CURRENCY_VALUE', 'Valeur : %s');
define('TEXT_INFO_CURRENCY_EXAMPLE', 'Exemple de sortie : %s =  %s');

define('TEXT_INFO_INSERT_INTRO', 'Merci de rentrer la nouvelle devise avec ces donées liées');
define('TEXT_INFO_DELETE_INTRO', 'Etes vous sur de vouloir supprimer cette devise ?');
define('TEXT_INFO_HEADING_NEW_CURRENCY', 'Nouvelle devise');
define('TEXT_INFO_HEADING_EDIT_CURRENCY', 'Modifier devise');
define('TEXT_INFO_HEADING_DELETE_CURRENCY', 'Supprimer devise');
define('TEXT_INFO_SET_AS_DEFAULT', TEXT_SET_DEFAULT . ' (Une mise à jour manuelle de la valeur de la devise requise)');
define('TEXT_INFO_CURRENCY_UPDATED', 'Le taux de change pour %s (%s) a été mis à jour avec succès par l\'intermédiaire de %s.');

define('ERROR_REMOVE_DEFAULT_CURRENCY', '<strong>Erreur :</strong> La devise par défaut ne peut être supprimée. Merci de choisir une autre devise par défaut et de réessayer.');
define('ERROR_CURRENCY_INVALID', '<strong>Erreur :</strong> Le taux de change pour %s (%s) n\'a pas été mis à jour par l\'intermédiaire de %s. S\'agit t\'il d\'un code devise valide ?');
define('WARNING_PRIMARY_SERVER_FAILED', '<strong>Warning:</strong> Le serveur de taux de change principal (%s) a echoué pour %s (%s) - essayer avec le serveur de taux de change secondaire.');

define('ERROR_INSTALL_CURRENCY_CONVERTER', 'Vous n\'avez pas de module de conversion de devises installé.  <a class="alert-link font-weight-bold" href="' . tep_href_link('modules.php', 'set=currencies') . '">Installer Maintenant</a>');
